;; Problem 42
;; 25 April 2003

;; The nth term of the sequence of triangle numbers is given by, Tn = 1/2n(n+1); so the first ten triangle numbers are:

;; 1, 3, 6, 10, 15, 21, 28, 36, 45, 55, ...

;; By converting each letter in a word to a number corresponding to its alphabetical position and adding these values we form a word value. For example, the word value for SKY is 19 + 11 + 25 = 55 = t10. If the word value is a triangle number then we shall call the word a triangle word.

;; Using words.txt (right click and 'Save Link/Target As...'), a 16K text file containing nearly two-thousand common English words, how many are triangle words?

(defvar *the-file* "/home/mortis/personal/projects/project-euler/problem-42-words-by-lines.txt")

;; (- (char-code (char "A" 0)) 64)
;; (- (char-code (char "a" 0)) 96)

(defmacro dbg (&rest rest)
  ())

(defun word->value (word)
  (loop 
   for char across word
   for total = (- (char-code char) 64) then (+ total (- (char-code char) 64))
   finally (return total)
   do
   (dbg
    (format t "char:~a val:~a total:~a~&"
	    char
	    (- (char-code char) 64)
	    total))))

;; (word->value "SKY")
;; (word->value "IS")

(defvar *word-table*
  (let ((ht (make-hash-table :test #'equal)))
    (with-open-file (in *the-file* :direction :input)
      (loop for line = (read-line in nil nil)
	    while line
	    do
	    (setf (gethash line ht) (word->value line))))
    ht))

(defun max-word-score ()
  (loop for word being the hash-keys of *word-table*
	using (hash-value score)
	maximizing score into max
	finally (return max)))

;; (max-word-score) ; 192

(defvar *triangle-table*
  (let ((max-score (max-word-score))
	(ht (make-hash-table :test #'equal)))
    (loop for nn = 1 then (+ nn 1)
	  for tri = (/ (* nn (+ nn 1)) 2)
               then (/ (* nn (+ nn 1)) 2)
	  while (< tri max-score)
	  do
	  (setf (gethash tri ht) t))
    ht))

(defun get-triangle-count ()
  (loop for word being the hash-keys of *word-table*
	using (hash-value value)
	with cnt = 0
	finally (return cnt)
	do
	(when (gethash value *triangle-table*)
	  (format t "~a triangle: ~a ~a~&"
		  cnt
		  word value)
	  (incf cnt))))

(format t "triangles:~a~&" (get-triangle-count))